unit MainFmxForm;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.WebBrowser,
  FMX.Controls.Presentation, FMX.ScrollBox, FMX.Memo, FMX.TabControl,
  MarkdownDaringFireball, MarkdownProcessor, FMX.StdCtrls;

type
  TForm1 = class(TForm)
    TabControl1: TTabControl;
    TabItem1: TTabItem;
    TabItem2: TTabItem;
    Memo1: TMemo;
    WebBrowser1: TWebBrowser;
    Memo2: TMemo;
    Splitter1: TSplitter;
    procedure Memo1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FMD: TMarkdownProcessor;
    procedure ProcessMarkdown;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FMD := TMarkdownProcessor.CreateDialect(mdDaringFireball);
  FMD.UnSafe := False;

  ProcessMarkdown;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FMD.Free;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  ProcessMarkdown;
end;

procedure TForm1.ProcessMarkdown;
var
  text, html: string;
begin
  text := Memo1.Lines.Text;
  html := FMD.process(text);

  Memo2.Lines.Text := html;

  WebBrowser1.LoadFromStrings(html, '');
end;

end.
