unit MainVclForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, MarkdownDaringFireball, MarkdownProcessor,
  Vcl.OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    WebBrowser1: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
  private
    { Private declarations }
    FMD: TMarkdownProcessor;

    procedure ProcessMarkdown;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  WebBrowser1.Navigate('about:blank');

  FMD := TMarkdownProcessor.CreateDialect(mdDaringFireball);
  FMD.UnSafe := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FMD.Free;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  ProcessMarkdown;
end;

procedure TForm1.ProcessMarkdown;
var
  text, html: string;
  Doc: Variant;
begin
  text := Memo1.Lines.Text;

  html := FMD.process(text);

  Memo2.Lines.Text := html;

  Doc := WebBrowser1.Document;
  Doc.clear;
  Doc.Write(html);
  Doc.close;
end;

end.
